<?php

/**
 * @file
 * Contains webtrees_settings_form
 */

module_load_include('inc','webtrees','src/Helper/WebtreesUser');

/**
 * webtrees_settings_form
 *
 * @param array $form
 * 
 * @param array $form_stata
 * 
 * @returns array
 */
function webtrees_test_form($form, &$form_state) {
    $form=array();

    if ($form_state['rebuild']) {
      $form_state['rebuild']=false;

      $form['state'] = array (
        '#type' => 'value',
        '#value' => 'result',
      );
      $form['results'] = array(
        '#type' => 'fieldset',
        '#title' => t('User test results'),
        '#collaspible' => TRUE,
        '#collasped' => FALSE,
        'result' => $form_state['values']['my_form_result'],
      );
      
      $form['actions']['#type'] = 'actions';
      $form['actions']['submit'] = array(
        '#type' => 'submit',
        '#value' => t('Try another'),
        '#button_type' => 'primary',
      );
    } else {
      $webtrees = new WebtreesUser();

      $error=$webtrees->connectError();
      if ($error) {
        $webtrees->close();

        return array( array (
          '#type' => 'item',
          '#title' => t('Connection failed: ').$error,
          '#markup' => t('Make sure the database settings are correct and try again.'),
          ));
      }

      $webtrees->close();

      $form['state'] = array (
        '#type' => 'value',
        '#value' => 'query',
      );

      $form['login'] = array(
        '#type' => 'details',
        '#title' => t('User login test'),
        '#open' => TRUE,
      );
      $form['login'][] = array (
        '#type' => 'item',
        '#title' => t('Note: '),
        '#markup' => t('This form can be used to test acess Webtrees user database. It will not log in the user or synchronize the user databases.'),
      );
      $form['login']['user'] = array(
	'#type' => 'textfield',
	'#title' => t('User name or email'),
	'#required' => TRUE,
      );
      $form['login']['password'] = array(
	      '#type' => 'password',
	      '#title' => t('Password'),
	      '#description' => t('Compare to the Webtrees user password if provided.'),
      );

      $form['actions']['#type'] = 'actions';
      $form['actions']['submit'] = array(
	      '#type' => 'submit',
  	    '#value' => t('Test login'),
	      '#button_type' => 'primary',
      );
    }

    // By default, render the form using system-config-form.html.twig.
    $form['#theme'] = 'system_config_form';

    return $form;
}

/**log
 * webtrees_settings_form_submit
 *
 * @param array $form
 * 
 * @param array $form_state
 */
function webtrees_test_form_submit($form, &$form_state) {
    if ($form_state['values']['state']!='query') {
      return;
    }

    $webtrees = new WebtreesUser();

    if ($webtrees->connectError()) {
      drupal_set_message(t('Connection failed: ').$webtrees->connectError(),'error');
    } else {
      $user=$form_state['values']['user'];
      $password=$form_state['values']['password'];

      if ($webtrees->load($user,'name_or_email')) {
        $form_state['rebuild']=TRUE;

        $rows[]['data']=[t('User ID'),$webtrees->user_id];
        $rows[]['data']=[t('User name'),$webtrees->user_name];
        $rows[]['data']=[t('Email'),$webtrees->email];
        $rows[]['data']=[t('Password'),$webtrees->hash];

        foreach($webtrees->settings as $key => $value){
         $rows[]['data']=[$key,$value];
        }
        
        $variables['header']=[t('Name'),t('Value')];
        $variables['rows']=$rows;
        $variables['attributes']=array();
        $variables['caption']='';
        $variables['colgroups']=array();
        $variables['sticky']=false;
        $variables['empty']='';
        
        $result[]= array (
           '#markup' => theme_table($variables),
           );

        $form_state['values']['my_form_result']=$result;

        if ($password) {
          if ($webtrees->passwordVerify($password)) {
            drupal_set_message(t('Password matches'));
          } else {
            drupal_set_message(t('Password DOES NOT MATCH').$password.'-','error');
          }
        }
        
        $drupal_user = user_load_by_name($webtrees->user_name);
        if ($drupal_user) {
          drupal_set_message(t('Drupal user matches by Webtrees user name'));
          if($webtrees->email!=$drupal_user->getEmail()) {
            drupal_set_message(t('Emails do not match'),'error');
          }
        } else {
          $drupal_user = user_load_by_mail($webtrees->email);
          if ($drupal_user) {
            drupal_set_message(t('Drupal user matches by Webtrees email'));
            if($webtrees->user_name!=$drupal_user->getUsername()) {
              drupal_set_message(t('Usernames do not match'),'error');
            }
          }
        }
        if ($drupal_user) {
          // check if blocked
        }
      } else {
        drupal_set_message(t('User not found: ').$user,'error');
      }
    }

    $webtrees->close();
}

